var config = {
    serverPort: 12345
}

var stats = {
    packetsReceived: 0,
    bytesReceived: 0
}

var testValue = 0;

// Connect to the websockets server
var websocket = new WebSocket("ws://localhost:" + config.serverPort);

websocket.binaryType = "arraybuffer";

websocket.onopen = function (event) {
    console.log("Connected to localhost:12345");
}

websocket.onclose = function (event) {
    console.log("Received " + stats.packetsReceived + " packets for a total of " + stats.bytesReceived + " bytes");
    console.log("Connection closed");
}

websocket.onmessage = function(event) {
    var arr = new Uint8Array(event.data);

    for (var i = 0; i < arr.length; i++) {
        // Compare expected and actual data to detect any corruption
        if (arr[i] != testValue) {
            console.error("Byte " + stats.bytesReceived + ": Expected " + testValue + ", got " + arr[i]);
            websocket.close();
            break;
        }
        testValue = (testValue + 1) & 0xFF;
        stats.bytesReceived++;
    }

    stats.packetsReceived++;
}